#include <assert.h>
#include "error.h"

const char *logfilter_strerror(logfilter_error err) {
	switch (err) {
	case ERR_OK:
		return "No error";
	case ERR_PARSE_FAILURE:
		return "Parse failure";
	case ERR_SYNTAX_ERROR:
		return "Syntax error";
	case ERR_ESCAPE_TOO_LONG:
		return "Escape sequence too long";
	case ERR_UTF8_CONVERSION_FAILED:
		return "Conversion from UTF-8 sequence failed";
	case ERR_INVALID_REGULAR_EXPRESSION:
		return "Invalid regular expression";
	case ERR_INTERNAL_ERROR:
		return "Internal error";
	case ERR_UNKNOWN_ERROR:
		return UNKNOWN_ERROR_STR;
	}
	assert(err && !"Unrecognized error code");
	return "Unknown error";
}

