#ifndef ARBVAL_H_
#define ARBVAL_H_

enum arbval_type_t {
	ARBVAL_TYPE_NULL = 0,
	ARBVAL_TYPE_INTEGER,
	ARBVAL_TYPE_STRING,
	ARBVAL_TYPE_REAL
};

struct arbval_t {
	enum arbval_type_t type;
	union {
		long integer;
		char *string;
		double real;
	} value;
};

struct arbval_t *arbval_create_null(void);
struct arbval_t *arbval_create_integer(long value);
struct arbval_t *arbval_create_string(const char *value);
struct arbval_t *arbval_create_real(double value);

void arbval_destroy(struct arbval_t *av);

struct arbval_t *arbval_clone(struct arbval_t *av);
void arbval_clone_into(struct arbval_t *dst, struct arbval_t *src);

void arbval_typecast_null(struct arbval_t *av);
void arbval_typecast_integer(struct arbval_t *av);
void arbval_typecast_string(struct arbval_t *av);
void arbval_typecast_real(struct arbval_t *av);

int arbval_is_true(struct arbval_t *av);
int arbval_is_false(struct arbval_t *av);

#endif
